/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCTPAGAR                                              */
/* Tabela : TIPOCTPAGAR                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCTPAGAR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCTPAGAR
GO

CREATE TRIGGER DTULTATU_TIPOCTPAGAR
ON TIPOCTPAGAR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCTPAGAR', null, 'CDTPCTPAGAR='+ CDTPCTPAGAR+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOCTPAGAR
      SET DTULTATUTPCP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOCTPAGAR.CDTPCTPAGAR,0) = ISNULL(INSERTED.CDTPCTPAGAR,0)) AND
            (ISNULL(TIPOCTPAGAR.DSTPCTPAGAR,0) = ISNULL(INSERTED.DSTPCTPAGAR,0)) AND
            (ISNULL(TIPOCTPAGAR.IDCTBLCTPAG,0) = ISNULL(INSERTED.IDCTBLCTPAG,0)) AND
            (ISNULL(TIPOCTPAGAR.DSDEFACTPAG,0) = ISNULL(INSERTED.DSDEFACTPAG,0)) AND
            (ISNULL(TIPOCTPAGAR.CDCLASSFINA,0) = ISNULL(INSERTED.CDCLASSFINA,0)) AND
            (ISNULL(TIPOCTPAGAR.IDUTLANCCPAG,0) = ISNULL(INSERTED.IDUTLANCCPAG,0))  ;
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPOCTPAGAR','5.05.045';
GO

