<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class EsoCadastro extends \Doctrine\ORM\EntityRepository {
    
    public function getEnviosEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $idativo = 'S', $nrchave = null, $nrtabela = null, $idoperacao = array(), $nrenvioexcl=null) {
        try{
            $esoCadastro = Repositories::ESO_CADASTRO;
            $esoEvento = Repositories::ESO_EVENTO;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nmevento' => $nmevento,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => $nrtpambiente,
                'idativo' => $idativo,
                'nrchave' => $nrchave,
                'nrtabela' => $nrtabela,
            );
            $sql = "SELECT envio
                      FROM $esoCadastro envio
                     WHERE envio.nrorg = :nrorg
                       AND envio.nmevento = :nmevento
                       AND envio.nrestruturam = :nrestruturam 
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.idativo = :idativo
                       AND (envio.nrchave = :nrchave OR :nrchave IS NULL)
                       AND (envio.nrtabela = :nrtabela OR :nrtabela IS NULL)";
            
            if (!empty($idoperacao)) {
                $sql .= " AND (envio.idoperacao IN ('".implode("','",$idoperacao)."'))";
            }
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function deleteEnviosExclusaoEmpregador($nrorg, $nrestruturam) {
        try{
            $esoCadastro = Repositories::ESO_CADASTRO;
            $esoNaoperiodico = Repositories::ESO_NAOPERIODICO;
            $esoPeriodico = Repositories::ESO_PERIODICO;
            $esoEnviocadastros = Repositories::ESO_ENVIOCADASTROS;
            $esoEvento = Repositories::ESO_EVENTO;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            
            $params = array(
                'nrorg' => $nrorg,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => 2,
            );
            $sql = "DELETE FROM $esoCadastro e
                     WHERE e.nrorg = :nrorg
                       AND e.nrestruturam = :nrestruturam 
                       AND e.nrtpambiente = :nrtpambiente";
            $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $params = array(
                'nrorg' => $nrorg,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => 2,
            );
            $sql = "DELETE FROM $esoNaoperiodico e
                     WHERE e.nrorg = :nrorg
                       AND e.nrestruturam = :nrestruturam 
                       AND e.nrtpambiente = :nrtpambiente";
            $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $params = array(
                'nrorg' => $nrorg,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => 2,
            );
            $sql = "DELETE FROM $esoPeriodico e
                     WHERE e.nrorg = :nrorg
                       AND e.nrestruturam = :nrestruturam 
                       AND e.nrtpambiente = :nrtpambiente";
            $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $params = array(
                'nrorg' => $nrorg,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => 2,
            );
            $sql = "DELETE FROM $esoEnviocadastros e
                     WHERE e.nrorg = :nrorg
                       AND e.nrestruturam = :nrestruturam 
                       AND e.nrtpambiente = :nrtpambiente";
            $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}