var Fis41000_Apuracao_Automatica_Controller = function(ZhFilterPreferences, ScreenService, templateManager, restEngine, General) {

    // Armazena o escopo atual.
    var self = this;
    var MESSAGE_SAVE_EDIT = 'Ao salvar a edição de uma Apuração, todos os arquivos existentes da mesma serão excluídos. Deseja realmente salvar?';
     
    self.openConfig = function(widget) {
        ScreenService.openWindow("fis_acessorias#fis41200_configuracao");
    };
    
    self.editApuracao = function(widget){
        widget.getField('NMEMPRESA').readOnly = true;   
        widget.getField('NMIMPOSTO').readOnly = true;   
        widget.getField('NMEMPRESA').reload();
        widget.getField('NMIMPOSTO').reload();
        General.edit(widget);
    };
    
    self.filtroApuracAuto = function(widget, preference){
        var currentRowFiltro = preference.FILTER_ROW;

        var cdempresa  = currentRowFiltro.CDEMPRESA;
        var cdimposto  = currentRowFiltro.CDIMPOSTO;
        var cdinscesta = currentRowFiltro.CDINSCESTA;
        
        /*widget.dataSourceFilter = widget.dataSourceFilter.filter(function(filter) {
            return (filter.operator !== 'LIKE_I' && (filter.name.search('VR') < 0) || filter.static == false);
        });*/

        widget.dataSourceFilter.forEach(function (filtro) {
            switch(filtro.name){
                case 'P_CDEMPRESA': filtro.value = cdempresa;
                    break;
                case 'P_CDIMPOSTO': filtro.value = cdimposto;
                    break;
                case 'P_CDINSCESTA': filtro.value = (cdinscesta && (cdinscesta != "")) ? cdinscesta : null;
                    break; 
            }
        });
    };
    
    self.empresaOnChange = function(widget){
        if(widget.currentRow.NMEMPRESA && widget.currentRow.NMEMPRESA != ''){
            widget.getField('CDINSCESTA').dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            widget.getField('CDINSCESTA').readOnly = false;
            widget.getField('CDINSCESTA').clearValue();
        } else {
            widget.getField('CDINSCESTA').dataSourceFilter = [];
            widget.getField('CDINSCESTA').readOnly = true;
            widget.getField('CDINSCESTA').clearValue();
        }
        widget.getField('CDINSCESTA').reload();
    };
    
    self.addApuracaoAutomatica = function(widget){
        widget.getField('NMEMPRESA').readOnly = true;
        widget.getField('NMIMPOSTO').readOnly = true;
        widget.newRow();
        widget.currentRow.CDEMPRESA = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
        widget.currentRow.NMEMPRESA = widget.appliedFilter.FILTER_ROW.NMEMPRESA;
        widget.currentRow.CDIMPOSTO = widget.appliedFilter.FILTER_ROW.CDIMPOSTO;
        widget.currentRow.NMIMPOSTO = widget.appliedFilter.FILTER_ROW.NMIMPOSTO;
        widget.currentRow.IDTPAPAUTO = 'T';
        widget.getField('CDINSCESTA').isVisible = false;
        widget.getField('NMGRUPINSCESTA').isVisible = false;
        widget.getField('CDINSCESTA').dataSourceFilter[0].value = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
        widget.getField('NMGRUPINSCESTA').dataSourceFilter[0].value = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
        if((widget.appliedFilter.FILTER_ROW.CDINSCESTA) && (widget.appliedFilter.FILTER_ROW.CDINSCESTA != "")){
            widget.currentRow.CDINSCESTA = widget.appliedFilter.FILTER_ROW.CDINSCESTA;
            widget.currentRow.NMREPRINSEST = widget.appliedFilter.FILTER_ROW.NMREPRINSEST;
            widget.currentRow.SGESTADO = widget.appliedFilter.FILTER_ROW.SGESTADO;
        }
    };
    
    self.changeTipoApura = function(widget){
        if(widget.currentRow.IDTPAPAUTO  == 'T'){
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
            widget.currentRow.CDINSCESTA = "";
        }
        else if(widget.currentRow.IDTPAPAUTO  == 'L'){
            widget.getField('CDINSCESTA').isVisible = true;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
            widget.getField('CDINSCESTA').clearValue();
            widget.getField('NMGRUPINSCESTA').clearValue();
        }
        else  if(widget.currentRow.IDTPAPAUTO  == 'A'){
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = true;
            widget.getField('CDINSCESTA').clearValue();
            widget.getField('NMGRUPINSCESTA').clearValue();
        }
        widget.getField('CDINSCESTA').reload();
        widget.getField('NMGRUPINSCESTA').reload();
    };
    
    self.onMoveRowTipoApura = function(widget){
        if(widget.currentRow.IDTPAPAUTO  == 'T'){
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
        }
        else if(widget.currentRow.IDTPAPAUTO  == 'L'){
            widget.getField('CDINSCESTA').isVisible = true;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
        }
        else  if(widget.currentRow.IDTPAPAUTO  == 'A'){
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = true;
        }
        widget.getField('CDINSCESTA').reload();
        widget.getField('NMGRUPINSCESTA').reload();
    };
    
    self.salvarApuracAutomatica = function(widget){
        if(widget.currentRow.__is_new == false){
            ScreenService.confirmMessage(ScreenService.i18n(MESSAGE_SAVE_EDIT), 'question', function (success) {
                self.saveApuracAuto(widget);
            });
        } else {
            self.saveApuracAuto(widget);
        }
    };
    
    self.saveApuracAuto = function(widget) {
        if (widget.isValid()) {
		    var dt2 = new Date(moment(widget.currentRow.DTJOBAPURAC, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var dtAtual = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
		    if(dt2.getTime() > dtAtual.getTime()){
		        if(widget.currentRow.DTVDPERIODO && widget.currentRow.DTVDPERIODO != ""){
    		        var dt1 = new Date(moment(widget.currentRow.DTVDPERIODO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
    		        if((dt2.getTime() >  dt1.getTime()) &&
    		            (dt1.getTime() > dtAtual.getTime()))
    		        {
                        widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                        widget.currentRow.NRORG = getLocalVar('NRORG');
                        widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY');
                        
                        General.callRestEngine('fis_apuracoes#/salvarApuracAutomatica','Row', widget.currentRow).then(
                            function(sucess){
                                widget.getField('NMEMPRESA').readOnlyOnEdit = false;   
                                widget.getField('NMIMPOSTO').readOnlyOnEdit = false;   
                                widget.getField('NMEMPRESA').reload();
                                widget.getField('NMIMPOSTO').reload();
                                ScreenService.goBack();
                                General.changeWidgetAcessibility(widget.widgets, true);
                                ScreenService.showMessage('Apuração salva com sucesso.');
                                ScreenService.goBack();
                                widget.reload();
                            }, function (error){
                                ScreenService.showMessage(error.error);
                            }
                        );
        		    } else {
        		        ScreenService.showMessage('A Data de Validade deve ser maior que a data atual, não pode ser igual a hora atual, e não pode ser maior que a Data de Apuração!');
        		    }
		        } else {
		            widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                        widget.currentRow.NRORG = getLocalVar('NRORG');
                        widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY');
                        
                        General.callRestEngine('fis_apuracoes#/salvarApuracAutomatica','Row', widget.currentRow).then(
                            function(sucess){
                                widget.getField('NMEMPRESA').readOnlyOnEdit = false;   
                                widget.getField('NMIMPOSTO').readOnlyOnEdit = false;   
                                widget.getField('NMEMPRESA').reload();
                                widget.getField('NMIMPOSTO').reload();
                                ScreenService.goBack();
                                General.changeWidgetAcessibility(widget.widgets, true);
                                ScreenService.showMessage('Apuração salva com sucesso.');
                                ScreenService.goBack();
                                widget.reload();
                            }, function (error){
                                ScreenService.showMessage(error.error);
                            }
                        );
		        } 
		    } else {
    	        ScreenService.showMessage('A Data de Apuração deve ser maior que a data atual, e não pode ser igual a hora atual!');
    	    }
        }
    };
    
    self.downloadArquivo = function(spedWidget) {
        var downloadRoute;
        var fileName;
        var serviceUrl;
        General.callRestEngine('fis_acessorias#/getFileServerUrl','Row', {'name': fileName}).then(
        function(sucess) {
            serviceUrl = sucess.dataset.sucess.fileName;
            //serviceUrl = sessionStorage.getItem('FileServerUrl');
            if(spedWidget.hasCheckedRows()){
                var rows = spedWidget.getCheckedRows();
                rows.forEach(function(row){
                    downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoApuracao?requestType=Row&row[NMARQUIVO]=";
                    if(row.NMPATHARQ.match('tmp')){    
                        window.open(downloadRoute+row.NMARQUIVO+'&row[NMPATHARQ]='+row.NMPATHARQ);
                    } else {    
                        downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoApuracaoFileServer?requestType=Row&row[NMARQUIVO]=";
                        var rowDownload = {
                            'NMARQUIVO':row.NMARQUIVO, 
                            'PATH': serviceUrl+row.NMPATHARQ
                        };
                        window.open(downloadRoute+rowDownload.NMARQUIVO+'&row[PATH]='+rowDownload.PATH);
                    }
                });
            } 
            else {
                var row = spedWidget.currentRow;
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMPATHARQ;
                if(fileName.match('tmp')){    
                    window.open(downloadRoute + row.NMARQUIVO);
                } else {
                    downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamentoFileServer?requestType=Row&row[NMARQUIVO]=";
                    var rowDownload = {
                        'NMARQUIVO':row.NMARQUIVO, 
                        'PATH': serviceUrl+fileName
                    };
                    window.open(downloadRoute+rowDownload.NMARQUIVO+'&row[PATH]='+rowDownload.PATH);
                }
            }
        });
    };
    
    self.deleteArquivo = function(spedWidget) {
        if(spedWidget.hasCheckedRows()){
            var rows = spedWidget.getCheckedRows();
            General.callRestEngine('fis_apuracoes#/deleteArquivo','DataSet', rows).then(
                function(sucesso){
                    spedWidget.reload();
                }, function(error){
                    ScreenService.showMessage(error.dataset.error);
                }
            );
        } 
        
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis41000_Apuracao_Automatica_Controller', Fis41000_Apuracao_Automatica_Controller);
});
